/*
 * Copyright (c) 2008-2014 Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global NX, Ext, Nexus*/

/**
 * Staging rule-set data store.
 *
 * @since staging 2.3
 */
NX.define('Nexus.staging.rule.RuleSetStore', {
    extend: 'Ext.data.JsonStore',

    mixins: [
        'Nexus.LogAwareMixin'
    ],

    constructor: function (config) {
        var self = this,
            config = config || {};

        Ext.apply(config, {
            url: Sonatype.config.servicePath + '/staging/rule_sets',
            root: 'data',
            id: 'id',

            fields: [
                { name: 'id' },
                { name: 'name' },
                { name: 'description' },
                { name: 'rules' },
                { name: 'resourceURI' }
            ],

            sortInfo: {
                field: 'name',
                direction: 'ASC'
            }
        });

        self.constructor.superclass.constructor.call(self, config);
    },

    /**
     * @public
     */
    nameForId: function(id) {
        var record = this.getById(id);
        if (record) {
            return record.get('name');
        }
        else {
            this.logDebug('Missing rule-set for ID:', id);
            // use id as name
            return id;
        }
    }
});